/*******************************************************************************
** HHE-071a 7-segment LED 3-digit Frequency Counter                           **
** 7ZOgLED3gJE^[                                          **
** 2016/06/26 Sun Version 1.00 PIC16F1827 mikroC PRO for PIC Version 6.6.2    **
** Copyright (C) 2016 by Hiroyuki UCHIDA (Beard UCHIDA) JG1CCL (W3CCL)        **
*******************************************************************************/

// 錾
extern void main();                     // C֐
extern void init_port();                // o̓|[g֐
extern void init_timer();               // ^C}[֐
extern long freq_measurement();         // g֐
extern void interrupt();                // 荞ݏ֐

// `
#define INPUT_MODE  1                   // ̓[h
#define OUTPUT_MODE 0                   // o̓[h

// |[gݒ
// ZOgڑݒ
sbit SEG1           at PORTA.B0;        // ZOg1̓|[gArbg0ɐڑ
sbit SEG1_Direction at TRISA.B0;        // Direction
#define SEG1_ON  SEG1 = 1               // ZOg1_
#define SEG1_OFF SEG1 = 0               // ZOg1
sbit SEG2           at PORTA.B1;        // ZOg2̓|[gArbg1ɐڑ
sbit SEG2_Direction at TRISA.B1;        // Direction
#define SEG2_ON  SEG2 = 1               // ZOg2_
#define SEG2_OFF SEG2 = 0               // ZOg2
sbit SEG3           at PORTA.B2;        // ZOg3̓|[gArbg2ɐڑ
sbit SEG3_Direction at TRISA.B2;        // Direction
#define SEG3_ON  SEG3 = 1               // ZOg3_
#define SEG3_OFF SEG3 = 0               // ZOg3

// 7ZOgLEDf[^ݒ
#define SEG_DATA           PORTB        // 7ZOgLED̓|[gBɐڑ
#define SEG_DATA_Direction TRISB        // Direction

// gJE^[Q[gݒ
sbit GATE            at PORTA.B4;       // Q[g̓|[gArbg4ɐڑ
sbit GATE_Direction  at TRISA.B4;       // Direction
#define GATE_ON  GATE = 1               // Q[gON
#define GATE_OFF GATE = 0               // Q[gOFF
#define GATE_OPEN GATE_Direction = INPUT_MODE   // Q[gJ
#define GATE_CLOSE GATE_Direction = OUTPUT_MODE // Q[g

// XCb`
sbit SW           at PORTA.B5;          // XCb`̓|[gArbg5ɐڑ
sbit SW_Direction at TRISA.B5;          // Direction
#define SW_ON  Button(&PORTA, 5, 1, 0)  // XCb`ON
#define SW_OFF Button(&PORTA, 5, 1, 1)  // XCb`OFF

// `
// ϐ
short gate_flag;                        // Q[gԃtOFJn =  0
                                        //                   I = 20
                                        //                   O   = -1
                                        //                   蒆   = ̑
short seg_flag;                         // ZOgڑtOFZOg1 = 0
                                        //                       ZOg2 = 1
                                        //                       ZOg3 = 2
short seg_data[3] = {0, 0, 0};          // ZOg\f[^
short dp;                               // _FZOg1 =  0
                                        //         ZOg2 =  1
                                        //         ZOg3 =  2
                                        //         Ȃ        = -1

// 7ZOgLEDf[^ON/OFFe[u
short LED_table[11] = {
// J
//    0b00111111,                       // 0
//    0b00000110,                       // 1
//    0b01011011,                       // 2
//    0b01001111,                       // 3
//    0b01100110,                       // 4
//    0b01101101,                       // 5
//    0b01111101,                       // 6
//    0b00000111,                       // 7
//    0b01111111,                       // 8
//    0b01100111,                       // 9
//    0b10000000                        // DPi_j

// 
    0b01111101,                         // 0
    0b01000001,                         // 1
    0b11011100,                         // 2
    0b11010101,                         // 3
    0b11100001,                         // 4
    0b10110101,                         // 5
    0b10111101,                         // 6
    0b01010001,                         // 7
    0b11111101,                         // 8
    0b11110001,                         // 9
    0b00000010                          // DPi_j
};

// C֐
void main()
{
    // `
    // ϐ
    long frequency;                     // g[Hz]
        
/* @Jn */
    // ݒ 16F1827 & 16F1847
    // OSCCON: OSCILLATOR CONTROL REGISTER
    // NbN8MHzɐݒ肷
    OSCCON = 0b01110000;

    // ANSELA: PORTA ANALOG SELECT REGISTER
    // fW^I/Oݒ肷
    ANSELA = 0b00000000;

    // ANSELB: PORTB ANALOG SELECT REGISTER
    // fW^I/Oݒ肷
    ANSELB = 0b00000000;

    init_port();                        // o̓|[g
    init_timer();                       // ^C}[
/* @I */

    // 
    gate_flag = -1;                     // Q[gԃtO𑪒Oɂ
    seg_flag = 0;                       // ZOg1ɂ
    SEG1_OFF;                           // ZOg1
    SEG2_OFF;                           // ZOg2
    SEG3_OFF;                           // ZOg3
    dp = -1;                            // _Ȃɂ

    // 荞݂
    INTCON.PEIE = 1;                    // ӊ݂
    INTCON.GIE = 1;                     // O[o荞݂
    T1CON.TMR1ON = 1;                   // TIMER1𓮍삳

    // JԂ
    while (1) {
        frequency = freq_measurement(); // g𑪒肷

        frequency = (frequency + 500) / 1000; // ľܓkHzɂ

        // XCb`ON̂Ƃɂ́A
        if (SW_ON) {
            // 7MHzъO_ŕ\
            dp = -1;                    // _Ȃɂ
            // 7.000MHẑƂɂ́A
            if (frequency < 7000) {
                dp = 0;                 // _ZOg1ɂ
            }
            // ȊO7.200MHz傫Ƃɂ́A
            else if (frequency > 7200) {
                dp = 2;                 // _ZOg3ɂ
            }
            
            // 1kHz
            seg_data[2] = frequency % 10;
            // 10kHz
            frequency /= 10;
            seg_data[1] = frequency % 10;
            // 100kHz
            frequency /= 10;
            seg_data[0] = frequency % 10;
        }

        // ȊÔƂɂ́A
        else {
            // 1MHẑƂɂ́A
            if (frequency < 1000) {
                dp = -1;                // _Ȃɂ
                // 1kHz
                seg_data[2] = frequency % 10;
                // 10kHz
                frequency /= 10;
                seg_data[1] = frequency % 10;
                // 100kHz
                frequency /= 10;
                seg_data[0] = frequency % 10;
            }

            // ȊO10MHẑƂɂ́A
            else if (frequency < 10000) {
                dp = 0;                 // _ZOg1ɂ
                // 10kHz
                frequency /= 10;
                seg_data[2] = frequency % 10;
                // 100kHz
                frequency /= 10;
                seg_data[1] = frequency % 10;
                // 1000kHz
                frequency /= 10;
                seg_data[0] = frequency % 10;
            }
            
            // ȊÔƂɂ́A
            else {
                dp = 1;                 // _ZOg2ɂ
                // 100kHz
                frequency /= 100;
                seg_data[2] = frequency % 10;
                // 1000kHz
                frequency /= 10;
                seg_data[1] = frequency % 10;
                // 10000kHz
                frequency /= 10;
                seg_data[0] = frequency % 10;
            }
        }
        Delay_ms(1000);              // 1b҂
    }
}

// o̓|[g
void init_port()
{
    SEG1_Direction = OUTPUT_MODE;       // ZOg1o͂ɐݒ肷
    SEG1_OFF;                           // ZOg1
    SEG2_Direction = OUTPUT_MODE;       // ZOg2o͂ɐݒ肷
    SEG2_OFF;                           // ZOg2
    SEG3_Direction = OUTPUT_MODE;       // ZOg3o͂ɐݒ肷
    SEG3_OFF;                           // ZOg3

    SEG_DATA_Direction = 0b00000000;    // 7ZOgLEDf[^o͂ɐݒ肷

    GATE_CLOSE;                         // Q[g
    GATE_OFF;                           // Q[gOFF

    SW_Direction = INPUT_MODE;          // XCb`͂ɐݒ肷
    OPTION_REG.NOT_WPUEN = 0;           // vAbvݒLɂ
    WPUA.WPUA5 = 1;                     // |[gArbg5̓vAbvLɂ
}

// ^C}[
void init_timer()
{
    //TIMER0̐ݒ
    OPTION_REG.TMR0CS = 1;              // T0CKIs̓͂gp
    OPTION_REG.TMR0SE = 0;              // OsオGbWw肷
    OPTION_REG.PSA = 0;                 // vXP[[gp
    OPTION_REG.PS0 = 0;                 // [g1/8ɐݒ肷
    OPTION_REG.PS1 = 1;
    OPTION_REG.PS2 = 0;

    // TIMER1̐ݒ
    T1CON.TMR1CS0 = 0;                  // NbN͂
    T1CON.TMR1CS1 = 0;
    T1CON.T1CKPS1 = 1;                  // vXP[[gp
    T1CON.T1CKPS0 = 1;                  // [g1/8ɐݒ肷
    T1CON.NOT_T1SYNC = 0;               // O͂NbN֓
    T1CON.T1OSCEN = 0;                  // OUH쓮Ȃ
    T1CON.TMR1ON = 0;                   // TIMER1𓮍삳Ȃ
    PIE1.TMR1IE = 0;                    // 荞݂֎~
    PIR1.TMR1IF = 0;                    // 荞݃tO
    TMR1L = 0;                          // TIMER10ɂ
    TMR1H = 0;

    // CCP1̐ݒ
    CCP1CON.CCP1M3 = 1;                 // RyA[[h
    CCP1CON.CCP1M2 = 0;                 //iXyVCxggK[jɐݒ肷
    CCP1CON.CCP1M1 = 1;
    CCP1CON.CCP1M0 = 1;
    PIE1.CCP1IE = 1;                    // 荞݂
    PIR1.CCP1IF = 0;                    // 荞݃tO
    CCPR1L = 0xE2;                      // 5[msec] =i1 / 8[MHz]j~4~8~1250
    CCPR1H = 0x04;
}

// g𑪒肷
// ߂lifrequencyjFg
long freq_measurement()
{
    long frequency;                     // g

    // 
    GATE_CLOSE;                         // Q[g
    GATE_OFF;                           // Q[gOFF
    INTCON.T0IF = 0;                    // TIMER0̊荞݃tO
    TMR0 = 0;                           // TIMER00ɂ
    frequency = 0;                      // g0ɂ
    gate_flag = 0;                      // Q[gԃtO𑪒Jnɂ

    // Q[gԃtOOɂȂ܂ŌJԂ
    while (gate_flag != -1) {
        // TIMER0̊荞݂Ƃɂ́A
        if (INTCON.T0IF == 1) {
            INTCON.T0IF = 0;            // TIMER0̊荞݃tO
            frequency++;                // gZ
        }
    }

    // Q[gԃtOOɂȂ钼OɁATIMER0̊荞݂Ƃɂ́A
    if (INTCON.T0IF == 1) {
        INTCON.T0IF = 0;                // TIMER0̊荞݃tO
        frequency++;                    // gZ
    }

    // gvZ
    frequency = ((frequency * 256) + TMR0) * 8 * 10;

    return (frequency);                 // g߂
}

// 荞ݏ֐
// RyA[[hiXyVCxggK[jCCP1IF荞݂𔭐B
// Q[gԂ𒲐B
// Q[gԃtOigate_flgjFJn =  0
//                               I = 20
//                               O   = -1
//                               蒆   = ̑
// ZOg_sB
// ZOgڑtOiseg_flagjFZOg1 = 0
//                                   ZOg2 = 1
//                                   ZOg3 = 2
// _idpjFZOg1 =  0
//               ZOg2 =  1
//               ZOg3 =  2
//               Ȃ        = -1
void interrupt()
{
    // CCP1IF荞݂Ƃɂ
    if (PIR1.CCP1IF == 1) {
        PIR1.CCP1IF = 0;                // CCP1IF荞݃tO

        // Q[gԃtOA
        switch (gate_flag) {
            // Jn̂Ƃɂ́A
            case 0:
                GATE_OPEN;              // Q[gJ
                gate_flag++;            // Q[gԃtOZ
                break;

            // ÎƂɂ́A
            case 20:
                GATE_CLOSE;             // Q[g
                GATE_OFF;               // Q[gOFF
                gate_flag = -1;         // Q[gԃtO-1ɂ
                break;

            // ÔƂɂ́A
            case -1:
                break;

            // 蒆̂Ƃɂ́A
            default:
                gate_flag++;            // Q[gԃtOZ
                break;
        }

        // ZOgڑtOA
        switch (seg_flag) {
            // ZOg1̂Ƃɂ́A
            case 0:
                SEG3_OFF;               // ZOg3
                SEG_DATA = LED_table[seg_data[0]];

                // _Ƃɂ́A
                if (dp == 0) SEG_DATA |= LED_table[10];
                SEG1_ON;                // ZOg1_
                seg_flag = 1;           // ZOg2ɂ
                break;

            // ZOg2̂Ƃɂ́A
            case 1:
                SEG1_OFF;               // ZOg1
                SEG_DATA = LED_table[seg_data[1]];
                // _Ƃɂ́A
                if (dp == 1) SEG_DATA |=  LED_table[10];
                SEG2_ON;                // ZOg2_
                seg_flag = 2;           // ZOg3ɂ
                break;

            // ZOg3̂Ƃɂ́A
            case 2:
                SEG2_OFF;               // ZOg2
                SEG_DATA = LED_table[seg_data[2]];
                // _Ƃɂ́A
                if (dp == 2) SEG_DATA |=  LED_table[10];
                SEG3_ON;                // ZOg3_
                seg_flag = 0;           // ZOg1ɂ
                break;
        }
    }
}

// End